
<?php

/**
* Clase Dispacher para Adelanto
*
* @package IM
* @subpackage AdelantoDP
* @author Willy
* @version SVN: : AdelantoDP.class.php,v 1.1 2009/06/01 13:16:53 Exp $
*/
class IngresoDiversosDP implements interfaceDP {

  protected $o_Bean;

  /**
  * Constructor donde asigna a un atributo el objeto AdelantoBean
  *
  * @param AdelantoBean $o_AdelantoBean
  */
  public function __construct(IngresoDiversosBean $o_IngresoDiversosBean){
  
    $this->o_Bean = $o_IngresoDiversosBean;
    
  }
  
  /**
  * Retorna el objeto AdelantoBean
  *
  * @return Object
  */
  protected function getObjetoBean(){
  
    if(!$this->o_Bean){
        $this->o_Bean = new IngresoDiversosBean();
    }        
    return $this->o_Bean;
    
  }
  
  /**
  * Ingresa un nuevo registro
  *
  * @return IdGenerado
  */
  public function save(){
    $con = Conexion::getConexion();
      $a_Fields = array();
      
      //if($this->getObjetoBean()->getIdGasto()) : $a_Fields['IdGasto'] = ($this->getObjetoBean()->getIdGasto()); endif;
      if($this->getObjetoBean()->getIdSucursal()) : $a_Fields['IdSucursal'] = ($this->getObjetoBean()->getIdSucursal()); endif;
      if($this->getObjetoBean()->getFechaIngreso()) : $a_Fields['FechaIngreso'] = ($this->getObjetoBean()->getFechaIngreso()); endif;
      if($this->getObjetoBean()->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getObjetoBean()->getDescripcion()); endif;
      if($this->getObjetoBean()->getDocumentoReferencia()) : $a_Fields['DocumentoReferencia'] = ($this->getObjetoBean()->getDocumentoReferencia()); endif;
      if($this->getObjetoBean()->getEliminado()) : $a_Fields['Eliminado'] = ($this->getObjetoBean()->getEliminado()); endif;
      if($this->getObjetoBean()->getMonto()) : $a_Fields['Monto'] = ($this->getObjetoBean()->getMonto()); endif;
      if($this->getObjetoBean()->getEstado()) : $a_Fields['Estado'] = ($this->getObjetoBean()->getEstado()); endif;
      if($this->getObjetoBean()->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getObjetoBean()->getUsuarioCreacion()); endif;
      if($this->getObjetoBean()->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getObjetoBean()->getFechaCreacion()); endif;
      if($this->getObjetoBean()->getUsuarioModificacion()) : $a_Fields['UsuarioModificacion'] = ($this->getObjetoBean()->getUsuarioModificacion()); endif;
      if($this->getObjetoBean()->getFechaModificacion()) : $a_Fields['FechaModificacion'] = ($this->getObjetoBean()->getFechaModificacion()); endif;
      if($this->getObjetoBean()->getFechaEliminado()) : $a_Fields['FechaEliminado'] = ($this->getObjetoBean()->getFechaEliminado()); endif;
      if($this->getObjetoBean()->getUsuarioEliminado()) : $a_Fields['UsuarioEliminado'] = ($this->getObjetoBean()->getUsuarioEliminado()); endif;
  
      
      $sStringField = arrayClass::implode_keys(',', $a_Fields);
      $sStringValue = "'".implode("','", $a_Fields)."'";

      $sql = "INSERT INTO cr_ingreso_diversos (".$sStringField.")
                      VALUES (".$sStringValue.");";
      
      $iResultSave = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      mysql_close($con);
      if($iResultSave > 0){
        return $iResultSave;
      }else{
        return false;
      }
  
  }
  
  
  /**
  * Modifica un nuevo registro
  *
  * @return IdGenerado
  */
  public function update() {

    if($this->getObjetoBean()->getIdIngreso()){
      $con = Conexion::getConexion();
      $a_Fields = array();
      
      if($this->getObjetoBean()->getIdIngreso()) : $a_Fields['IdIngreso'] = ($this->getObjetoBean()->getIdIngreso()); endif;      
      if($this->getObjetoBean()->getIdSucursal()) : $a_Fields['IdSucursal'] = ($this->getObjetoBean()->getIdSucursal()); endif;
      if($this->getObjetoBean()->getFechaIngreso()) : $a_Fields['FechaIngreso'] = ($this->getObjetoBean()->getFechaIngreso()); endif;
      if($this->getObjetoBean()->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getObjetoBean()->getDescripcion()); endif;
      if($this->getObjetoBean()->getDocumentoReferencia()) : $a_Fields['DocumentoReferencia'] = ($this->getObjetoBean()->getDocumentoReferencia()); endif;
      if($this->getObjetoBean()->getEliminado()) : $a_Fields['Eliminado'] = ($this->getObjetoBean()->getEliminado()); endif;
      if($this->getObjetoBean()->getEstado()) : $a_Fields['Estado'] = ($this->getObjetoBean()->getEstado()); endif;
      if($this->getObjetoBean()->getMonto()) : $a_Fields['Monto'] = ($this->getObjetoBean()->getMonto()); endif;
      if($this->getObjetoBean()->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getObjetoBean()->getUsuarioCreacion()); endif;
      if($this->getObjetoBean()->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getObjetoBean()->getFechaCreacion()); endif;
      if($this->getObjetoBean()->getUsuarioModificacion()) : $a_Fields['UsuarioModificacion'] = ($this->getObjetoBean()->getUsuarioModificacion()); endif;
      if($this->getObjetoBean()->getFechaModificacion()) : $a_Fields['FechaModificacion'] = ($this->getObjetoBean()->getFechaModificacion()); endif;
      if($this->getObjetoBean()->getFechaEliminado()) : $a_Fields['FechaEliminado'] = ($this->getObjetoBean()->getFechaEliminado()); endif;
      if($this->getObjetoBean()->getUsuarioEliminado()) : $a_Fields['UsuarioEliminado'] = ($this->getObjetoBean()->getUsuarioEliminado()); endif;
      
      
      $sString = arrayClass::implode_key_value(",", $a_Fields);

      $sql = "UPDATE cr_ingreso_diversos  SET
                  ".$sString."
            WHERE 1 AND IdIngreso= '".$this->getObjetoBean()->getIdIngreso()."' ";
      
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
     
      mysql_close($con);
      
      $iResultSave = $result;
      if($iResultSave){
        return $iResultSave;
      }else{
        return false;
      }

    }else{
      return false;
    }

  }
  
  
  /**
  * Elimina registro
  *
  * @return Boolean
  */
  public function delete(){
    
      $o_IngresoDiversos = new IngresoDiversosBean();
      
      $con = Conexion::getConexion();
      
      if($this->getObjetoBean()->getIdIngreso()){
          $o_IngresoDiversos->setIdIngreso($this->getObjetoBean()->getIdIngreso());
      }
            
      $sql = "UPDATE cr_ingreso_diversos 
              SET
                Eliminado = '1',
                FechaEliminado = '".date('Y-m-d H:i:s')."',
                UsuarioEliminado = '".$this->getObjetoBean()->getUsuarioEliminado()."'
            WHERE IdIngreso= '".$this->getObjetoBean()->getIdIngreso()."' ";
      
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      
      $num_rows = mysql_affected_rows($con);
      mysql_close($con);
                  
      $iResultDelete = $num_rows;
      if($iResultDelete){
          return 1;
      }else{
          return false;
      }    
    
  }
  
 
  /**
  * Selecciona un nuevo registro
  *
  * @return IdGenerado
  */
  public function select(){
    $tamPag           = is_null($this->getObjetoBean()->tamPag)?1:$this->getObjetoBean()->tamPag;
    $pagina           = is_null($this->getObjetoBean()->page)?1:$this->getObjetoBean()->page;
    $numeroRegistros  = $this->selectNumRows();
    $limitInf         = ($pagina-1)*$tamPag;
    
    $where = $this->buildConsult();
    $orden = $this->buildOrderByField();
    
    $con = Conexion::getConexion();
    $sql = "SELECT ind.IdIngreso, su.IdSucursal, su.Descripcion,ind.DocumentoReferencia, ind.Monto,ind.Estado,ind.FechaIngreso,ind.UsuarioModificacion, ind.FechaModificacion ,ind.UsuarioCreacion, ind.FechaCreacion
            FROM cr_ingreso_diversos ind
             LEFT JOIN cr_sucursal su ON ind.IdSucursal = su.IdSucursal 
            WHERE ind.Eliminado <> '1' ".
            $where." ".$orden." LIMIT ".$limitInf.",".$tamPag;
    
    //echo $sql;
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);

    $a_tmp = array();

    if($num_rows>0){
      while ($o_valor = mysql_fetch_object($result)) {
      $a_tmp[] = $this->insertarObjetoBean($o_valor);
      }
    }

    mysql_close($con);
   
    return count($a_tmp)>0?$a_tmp:null;
      
  }
   public function buildOrderByField(){
    $order_by = "";
    if($this->getObjetoBean()->sortCampos || $this->getObjetoBean()->sortCampos != ""){
      $a_valCampos = explode(";", $this->getObjetoBean()->sortCampos);
      $a_valtype   = explode(";", $this->getObjetoBean()->sortType);
      $order_by = " ORDER BY ";
      $a_order = array();
      foreach ($a_valCampos as $key => $val){
        $sTmpOrder = "";
        if(array_key_exists($val, self::$fieldNames)){
          $sTmpOrder .= self::$fieldNames[$val];
          switch ($a_valtype[$key]){
            case 1: $sTmpOrder .= " ASC"; break;
            case 2: $sTmpOrder .= " DESC"; break;
          }
          $a_order[] = $sTmpOrder;
        }
      }
      $order_by .= implode(", ", $a_order);
    }
    return $order_by;
  }
  
  
  /**
  * Retorna un objeto AdelantoBean
  *
  * @return Object
  */
 
  public function selectByPk(){
  
    $con = Conexion::getConexion();
    $sql = "SELECT ind.IdIngreso, su.IdSucursal, su.Descripcion,ind.Descripcion as DescripcionGasto,ind.DocumentoReferencia, ind.Monto,ind.Estado,ind.FechaIngreso,ind.UsuarioModificacion, ind.FechaModificacion ,ind.UsuarioCreacion, ind.FechaCreacion
             FROM cr_ingreso_diversos ind
             LEFT JOIN cr_sucursal su ON ind.IdSucursal = su.IdSucursal 
    		 WHERE  ind.Eliminado <> '1' and IdIngreso='".$this->getObjetoBean()->getIdIngreso()."' ";
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $o_Propel = $result ? mysql_fetch_object($result) : null;
    mysql_close($con);
    //echo $sql;
    return $o_Propel?$this->insertarObjetoBean($o_Propel):null;
  
  }
  
   
  
  /**
  * Reasigna valores retornados del propel a un objeto AdelantoBean
  *
  * @param Object $o_Propel
  * @return AdelantoBean
  */
 private function insertarObjetoBean($o_Propel){

    $o_IngresoDiversosBean = new IngresoDiversosBean();
    
    $o_IngresoDiversosBean->setIdIngreso($o_Propel->IdIngreso);
    $o_IngresoDiversosBean->setIdSucursal($o_Propel->IdSucursal);
    $o_IngresoDiversosBean->setFechaIngreso($o_Propel->FechaIngreso);
    $o_IngresoDiversosBean->setDescripcion($o_Propel->DescripcionGasto);
    $o_IngresoDiversosBean->setDocumentoReferencia($o_Propel->DocumentoReferencia);
    $o_IngresoDiversosBean->setMonto($o_Propel->Monto);
    $o_IngresoDiversosBean->setEstado($o_Propel->Estado);
    $o_IngresoDiversosBean->setEliminado($o_Propel->Eliminado);
    $o_IngresoDiversosBean->setUsuarioCreacion($o_Propel->UsuarioCreacion);
    $o_IngresoDiversosBean->setFechaCreacion($o_Propel->FechaCreacion);
    $o_IngresoDiversosBean->setUsuarioModificacion($o_Propel->UsuarioModificacion);
    $o_IngresoDiversosBean->setFechaModificacion($o_Propel->FechaModificacion);
    $o_IngresoDiversosBean->setFechaEliminado($o_Propel->FechaEliminado);
    $o_IngresoDiversosBean->setUsuarioEliminado($o_Propel->UsuarioEliminado);
       
    return $o_IngresoDiversosBean;    
    
  }
  public function selectNumRows(){
    
    $where = $this->buildConsult();
    
    $con = Conexion::getConexion();
    $sql = "SELECT ind.IdIngreso, su.IdSucursal, su.Descripcion, ind.Monto,ind.Estado,ind.FechaIngreso,ind.UsuarioModificacion, ind.FechaModificacion 
             FROM cr_ingreso_diversos ind
             LEFT JOIN cr_sucursal su ON ind.IdSucursal = su.IdSucursal 
     		WHERE ind.Eliminado <> '1'".$where;
   
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
    
    mysql_close($con);
   
    return $num_rows;
    
  }
  private function buildConsult(){
    
    $where = "";
    
    if($this->getObjetoBean()->getIdIngreso()){
       $where .= " AND IdIngreso  = '".$this->getObjetoBean()->getIdIngreso()."'";
    }
    if($this->getObjetoBean()->getIdSucursal()){
      
       $where .= " AND ind.IdSucursal= '".$this->getObjetoBean()->getIdSucursal()."'";
       
    }
     if($this->getObjetoBean()->getFechaIngreso()){
       $where .= " AND FechaIngreso >='".$this->getObjetoBean()->getFechaIngreso()."'";
    }
     if($this->getObjetoBean()->getFechaFinal()){
       $where .= " AND FechaIngreso <= '".$this->getObjetoBean()->getFechaFinal()."'";
    }
    if($this->getObjetoBean()->getEstado()){
        $where .= " AND ind.Estado  = '".$this->getObjetoBean()->getEstado()."'";
    }
   
    return $where;
    
  }
  function selectResultset(){
    
    $tamPag           = is_null($this->getObjetoBean()->tamPag)?9999:$this->getObjetoBean()->tamPag;
    $pagina           = is_null($this->getObjetoBean()->page)?1:$this->getObjetoBean()->page;
    $numeroRegistros  = $this->selectNumRows();
    $limitInf         = ($pagina-1)*$tamPag;
    
    $where = $this->buildConsult();
    
    
    $con = Conexion::getConexion();
    $sql = "SELECT ind.IdIngreso, su.IdSucursal, su.Nombres, ind.Monto,ind.Estado,ind.FechaIngreso,ind.UsuarioModificacion, ind.FechaModificacion 
             FROM cr_ingreso_diversos ind
             LEFT JOIN cr_sucursal su ON ind.IdSucursal = su.IdSucursal 
            WHERE ind.Eliminado <> '1' ".
            $where." ".$orden." LIMIT ".$limitInf.",".$tamPag;
    
    //echo $sql;
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
    
    mysql_close($con);

    $a_tmp = array();

    if($num_rows>0){
      
      return $result;
      
    }else{
      return null;
    }
        
  }
    
}

